LPARAMETERS lcText, lcStart, lcEnd, llSilent, llHTML
** Procedra upildo tekst pagal ablon
* Pavyzdiui <<kodas_ks>> upildo reikme KS001

* Parametrai:
* Teksto ablonas
* [ablono pradia] - pagal nutyljim '<<'
* [ablono pabaiga] - pagal nutyljim '>>'
* [nemesti klaidos praneimo] - pagal nutyljim .F. (metamas praneimas)
* [ar pateiktas ablonas yra HTML tekstas] - pagal nutyljim .F. (paprastas tekstas)

* Marius Rubinas
* 2020.05.07

_klaida=.F.

IF TYPE("m.lcText")#"C"
	RETURN ""
ENDIF
IF EMPTY(NVL(m.lcText,""))
	RETURN m.lcText
ENDIF

IF TYPE("m.lcStart")#"C" OR EMPTY(NVL(m.lcStart,""))
	m.lcStart="<<"
	IF !EMPTY(m.llHTML)
		m.lcStart="&lt;&lt;"
	ENDIF
ENDIF

IF TYPE("m.lcEnd")#"C" OR EMPTY(NVL(m.lcEnd,""))
	m.lcEnd=">>"
	IF !EMPTY(m.llHTML)
		m.lcEnd="&gt;&gt;"
	ENDIF
ENDIF

LOCAL lcRez, lcCommand, _err, x, y
m._err=.F.
m.x=ATC(m.lcStart,m.lcText)
DO WHILE m.x>0
	m.y=ATC(m.lcEnd,SUBSTR(m.lcText,m.x+LEN(m.lcStart)))
	IF m.y=0
		RETURN m.lcText && EXIT
	ENDIF
	
	m.lcCommand=SUBSTR(m.lcText,m.x+LEN(m.lcStart),m.y-1)
	m.lcCommand=CHRTRAN(m.lcCommand,[],["""])
	m.lcCommand=CHRTRAN(m.lcCommand,[],['])
	TRY
		m.lcRez=&lcCommand
	CATCH TO m._err
	ENDTRY
	IF TYPE("m._err")="O" AND !ISNULL(m._err) && Klaida
		=l_window(l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),150),"P")
		IF EMPTY(m.llSilent)
			=f_info(l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),150)+CHR(13)+l_tek([Komanda: ]+m.lcCommand),.T.)
		ENDIF
		_klaida=l_tek([Klaida: ])+LEFT(ALLTRIM(m._err.message),150)
		RETURN m.lcText && EXIT
	ENDIF
	DO CASE
		CASE TYPE("m.lcRez")="C" OR TYPE("m.lcRez")="M"
			m.lcRez=m.lcRez
		CASE TYPE("m.lcRez")="N"
			m.lcRez=ALLTRIM(STR(m.lcRez,10,2))
		CASE TYPE("m.lcRez")="L"
			m.lcRez=IIF(m.lcRez,".T.",".F.")
		CASE TYPE("m.lcRez")="D"
			m.lcRez=DTOC(m.lcRez)
		CASE TYPE("m.lcRez")="T"
			m.lcRez=TTOC(m.lcRez)
		OTHERWISE
			m.lcRez=""
	ENDCASE
	
	IF !EMPTY(m.llHTML)
		m.lcRez=xml_encode(m.lcRez)
	ENDIF
	m.lcText=SUBSTR(m.lcText,1,m.x-1)+m.lcRez+SUBSTR(m.lcText,m.x+LEN(m.lcStart)+m.y+LEN(m.lcEnd)-1)
	
	m.x=ATC(m.lcStart,m.lcText)
ENDDO
RETURN m.lcText

ENDPROC